"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.GlArticle = void 0;
var jsx_runtime_1 = require("react/jsx-runtime");
var react_1 = require("react");
var theme_1 = require("./theme");
var theme_2 = require("./theme");
var react_markdown_1 = __importDefault(require("react-markdown"));
var GlButton_1 = require("./utils/GlButton");
var GlAnimatedOnScroll_1 = require("./GlAnimatedOnScroll");
var useStyles = theme_1.makeStyles()(function (theme, illustrationPosition) { return ({
    "root": __assign(__assign({ "display": "flex", "flexDirection": (function () {
            if (illustrationPosition === "left" &&
                theme.windowInnerWidth >= theme_2.breakpointsValues.md) {
                return "row-reverse";
            }
            if (theme.windowInnerWidth < theme_2.breakpointsValues.md) {
                return "column";
            }
            return undefined;
        })(), "alignItems": "center", "& code": {
            "width": 0,
        } }, (function () {
        var value = theme.spacing(7);
        return {
            "marginTop": value,
            "marginBottom": value,
        };
    })()), (function () {
        var value = theme.spacing(8);
        if (theme.windowInnerWidth < theme_2.breakpointsValues.lg) {
            return undefined;
        }
        if (illustrationPosition === "left") {
            return {
                "paddingRight": value,
            };
        }
        return {
            "paddingLeft": value,
        };
    })()),
    "article": __assign({ "display": "flex", "flexDirection": "column", "textAlign": "left", "width": (function () {
            if (theme.windowInnerWidth >= theme_2.breakpointsValues.xl) {
                return 412;
            }
            if (theme.windowInnerWidth >= theme_2.breakpointsValues["lg+"]) {
                return 311;
            }
            if (theme.windowInnerWidth >= theme_2.breakpointsValues.md) {
                return 270;
            }
            return undefined;
        })() }, (function () {
        var value = theme.windowInnerWidth >= theme_2.breakpointsValues.lg
            ? theme.spacing(9)
            : theme.spacing(5);
        if (theme.windowInnerWidth < theme_2.breakpointsValues.md) {
            return undefined;
        }
        if (illustrationPosition === "left") {
            return {
                "marginLeft": value,
            };
        }
        return {
            "marginRight": value,
        };
    })()),
    "body": __assign(__assign({}, theme.typography.variants["body 1"].style), { "margin": theme.spacing({
            "topBottom": 4,
            "rightLeft": 0,
        }), "color": theme.colors.useCases.typography.textSecondary }),
    "buttonWrapper": {
        "display": "flex",
        "justifyContent": "flex-end",
    },
    "button": {
        "alignSelf": "right",
    },
    "illustrationWrapper": {
        "flex": 1,
    },
}); });
exports.GlArticle = react_1.memo(function (props) {
    var illustration = props.illustration, body = props.body, buttonLabel = props.buttonLabel, illustrationPosition = props.illustrationPosition, title = props.title, className = props.className, buttonLink = props.buttonLink;
    var _a = useStyles(illustrationPosition !== null && illustrationPosition !== void 0 ? illustrationPosition : "right"), classes = _a.classes, cx = _a.cx, theme = _a.theme;
    var _b = __read(react_1.useState(function () {
        return {
            "initial": {
                "x": (function () {
                    var value = theme.windowInnerWidth >= theme_2.breakpointsValues.lg
                        ? 300
                        : 150;
                    switch (illustrationPosition) {
                        case "left":
                            return value;
                        case "right":
                            return -value;
                        default:
                            return -value;
                    }
                })(),
                "opacity": 0,
            },
            "animate": {
                "x": 0,
                "opacity": 1,
            },
            "transition": {
                "duration": 1,
                "type": "tween",
                "ease": "easeOut",
            },
        };
    }), 1), textAnimationProps = _b[0];
    return (jsx_runtime_1.jsxs("section", __assign({ className: cx(classes.root, className) }, { children: [jsx_runtime_1.jsxs("article", __assign({ className: classes.article }, { children: [title && (jsx_runtime_1.jsx(GlAnimatedOnScroll_1.GlAnimatedOnScroll, __assign({}, textAnimationProps, { children: jsx_runtime_1.jsx(theme_1.Text, __assign({ typo: "page heading" }, { children: title }), void 0) }), void 0)),
                    body && (jsx_runtime_1.jsx(GlAnimatedOnScroll_1.GlAnimatedOnScroll, __assign({}, textAnimationProps, { children: jsx_runtime_1.jsx(react_markdown_1.default, __assign({ className: classes.body }, { children: body }), void 0) }), void 0)),
                    buttonLabel && (jsx_runtime_1.jsx(GlAnimatedOnScroll_1.GlAnimatedOnScroll, __assign({}, textAnimationProps, { children: jsx_runtime_1.jsx("div", __assign({ className: classes.buttonWrapper }, { children: jsx_runtime_1.jsx(GlButton_1.GlButton, __assign({ className: classes.button, type: "submit", href: buttonLink === null || buttonLink === void 0 ? void 0 : buttonLink.href, onClick: buttonLink === null || buttonLink === void 0 ? void 0 : buttonLink.onClick, variant: "secondary" }, { children: buttonLabel }), void 0) }), void 0) }), void 0))] }), void 0),
            jsx_runtime_1.jsx(GlAnimatedOnScroll_1.GlAnimatedOnScroll, __assign({ initial: {
                    "opacity": 0,
                }, animate: {
                    "opacity": 1,
                }, transition: {
                    "delay": 1,
                    "duration": 0.5,
                }, className: classes.illustrationWrapper }, { children: jsx_runtime_1.jsx("aside", { children: illustration }, void 0) }), void 0)] }), void 0));
});
//# sourceMappingURL=GlArticle.js.map