"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.GlReviewSlide = void 0;
var jsx_runtime_1 = require("react/jsx-runtime");
var theme_1 = require("./theme");
var react_1 = require("react");
var GlLogo_1 = require("./utils/GlLogo");
var Paper_1 = __importDefault(require("@material-ui/core/Paper"));
var react_markdown_1 = __importDefault(require("react-markdown"));
var theme_2 = require("./theme");
var useStyles = theme_1.makeStyles()(function (theme) { return ({
    "root": {
        "display": "flex",
        "alignItems": "center",
        "justifyContent": "space-between",
        "position": "relative",
        "flexDirection": (function () {
            if (theme.windowInnerWidth >= theme_2.breakpointsValues.md) {
                return "row";
            }
            return "column";
        })(),
    },
    "paragraph": __assign(__assign({}, theme.typography.variants["body 1"].style), { "textAlign": (function () {
            if (theme.windowInnerWidth >= theme_2.breakpointsValues.md) {
                return undefined;
            }
            return "center";
        })(), "margin": (function () {
            if (theme.windowInnerWidth >= theme_2.breakpointsValues.sm) {
                return theme.spacing(5);
            }
            return theme.spacing({
                "topBottom": 1,
                "rightLeft": 5,
            });
        })() }),
    "signature": {
        "fontStyle": "italic",
        "marginRight": theme.spacing((function () {
            if (theme.windowInnerWidth >= theme_2.breakpointsValues.md) {
                return 5;
            }
            return 0;
        })()),
        "marginBottom": theme.spacing(5),
        "textAlign": (function () {
            if (theme.windowInnerWidth >= theme_2.breakpointsValues.md) {
                return "right";
            }
            return "center";
        })(),
    },
    "logo": __assign({ "width": 70, "& svg": {
            "width": 70,
            "height": 70,
        } }, (function () {
        if (theme.windowInnerWidth >= theme_2.breakpointsValues.md) {
            return {
                "marginLeft": theme.spacing(5),
            };
        }
        return {
            "marginLeft": 0,
            "marginTop": theme.spacing(5),
        };
    })()),
}); });
exports.GlReviewSlide = react_1.memo(function (props) {
    var descriptionMd = props.descriptionMd, className = props.className, signature = props.signature, logoUrl = props.logoUrl;
    var _a = useStyles(), classes = _a.classes, cx = _a.cx;
    return (jsx_runtime_1.jsxs(Paper_1.default, __assign({ className: cx(classes.root, className) }, { children: [logoUrl !== undefined && (jsx_runtime_1.jsx(GlLogo_1.GlLogo, { logoUrl: logoUrl, className: classes.logo }, void 0)),
            jsx_runtime_1.jsxs("div", { children: [descriptionMd !== undefined && (jsx_runtime_1.jsx(react_markdown_1.default, __assign({ className: classes.paragraph }, { children: descriptionMd }), void 0)),
                    signature !== undefined && (jsx_runtime_1.jsx(theme_1.Text, __assign({ typo: "body 2", className: classes.signature }, { children: signature }), void 0))] }, void 0)] }), void 0));
});
//# sourceMappingURL=GlReviewSlide.js.map