"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.GlSlider = void 0;
var jsx_runtime_1 = require("react/jsx-runtime");
var react_1 = require("react");
var react_2 = require("embla-carousel/react");
var theme_1 = require("./theme");
var theme_2 = require("./theme");
var useCallbackFactory_1 = require("powerhooks/useCallbackFactory");
var useStyles = theme_1.makeStyles()(function (theme) { return ({
    "root": __assign({}, (function () {
        var value = theme.spacing(7);
        return {
            "marginTop": value,
            "marginBottom": value,
        };
    })()),
    "heading": {
        "textAlign": "center",
        "marginBottom": theme.spacing(10),
    },
    "sliderWrapper": {
        "position": "relative",
        "display": "flex",
        "alignItems": "center",
        "justifyContent": "center",
    },
    "viewport": {
        "overflow": "hidden",
        "userSelect": "none",
    },
    "container": {
        "display": "flex",
        "alignItems": "center",
    },
    "arrows": {
        "transition": "transform 300ms",
        ":hover": {
            "transform": "scale(1.2)",
        },
    },
    "slide": __assign({ "position": "relative", "minWidth": "100%", "display": "flex", "justifyContent": "center", "overflow": "hidden" }, theme.spacing.rightLeft("padding", 4)),
}); });
exports.GlSlider = react_1.memo(function (props) {
    var className = props.className, slides = props.slides, title = props.title;
    var _a = __read(react_2.useEmblaCarousel({ "loop": true }), 2), emblaRef = _a[0], emblaApi = _a[1];
    var onClickFactory = useCallbackFactory_1.useCallbackFactory(function (_a) {
        var _b = __read(_a, 1), direction = _b[0];
        if (emblaApi === undefined) {
            return;
        }
        switch (direction) {
            case "left":
                emblaApi.scrollPrev();
                break;
            case "right":
                emblaApi.scrollNext();
        }
    });
    var _b = useStyles(), classes = _b.classes, cx = _b.cx;
    return (jsx_runtime_1.jsxs("section", __assign({ className: cx(classes.root, className) }, { children: [title !== undefined && (jsx_runtime_1.jsx(theme_1.Text, __assign({ className: classes.heading, typo: "page heading" }, { children: title }), void 0)),
            jsx_runtime_1.jsxs("div", __assign({ className: classes.sliderWrapper }, { children: [jsx_runtime_1.jsx(theme_2.Icon, { iconId: "arrowBackIos", className: classes.arrows, onClick: onClickFactory("left") }, void 0),
                    jsx_runtime_1.jsx("div", __assign({ className: classes.viewport, ref: emblaRef }, { children: jsx_runtime_1.jsx("div", __assign({ className: classes.container }, { children: slides !== undefined &&
                                slides.map(function (slide) { return (jsx_runtime_1.jsx("div", __assign({ className: classes.slide }, { children: slide }), void 0)); }) }), void 0) }), void 0),
                    jsx_runtime_1.jsx(theme_2.Icon, { iconId: "arrowForwardIos", className: classes.arrows, onClick: onClickFactory("right") }, void 0)] }), void 0)] }), void 0));
});
//# sourceMappingURL=GlSlider.js.map