"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.GlTemplate = void 0;
var jsx_runtime_1 = require("react/jsx-runtime");
var react_1 = require("react");
var theme_1 = require("./theme");
var onyxia_ui_1 = require("onyxia-ui");
var ThemeProvider_1 = require("onyxia-ui/lib/ThemeProvider");
var theme_2 = require("./theme");
var onyxia_ui_2 = require("onyxia-ui");
var hooks_1 = require("evt/hooks");
var evt_1 = require("evt");
var onyxia_ui_3 = require("onyxia-ui");
var useStyles = theme_1.makeStyles()(function (theme, _a) {
    var headerHeight = _a.headerHeight, rootWidth = _a.rootWidth, isHeaderVisible = _a.isHeaderVisible, headerPosition = _a.headerPosition;
    var paddingRightLeft = theme.spacing((function () {
        if (theme.windowInnerWidth >= theme_2.breakpointsValues["lg"]) {
            return 7;
        }
        if (theme.windowInnerWidth >= theme_2.breakpointsValues["sm"]) {
            return 6;
        }
        return 4;
    })());
    return {
        "root": __assign({ "height": "100%" }, (function () {
            switch (headerPosition) {
                case "fixed":
                    return {
                        "visibility": headerHeight === 0 || rootWidth === 0
                            ? "hidden"
                            : "visible",
                    };
                case "top":
                    return {
                        "overflow": "auto",
                        "scrollBehavior": "smooth",
                    };
            }
        })()),
        "headerWrapper": __assign(__assign({}, theme.spacing.rightLeft("padding", paddingRightLeft + "px")), (function () {
            switch (headerPosition) {
                case "fixed":
                    return {
                        "zIndex": 1000,
                        "position": "fixed",
                        "width": rootWidth,
                        "transition": "top 350ms",
                        "top": isHeaderVisible ? 0 : -headerHeight,
                        "backgroundColor": onyxia_ui_3.changeColorOpacity({
                            "color": theme.colors.useCases.surfaces.background,
                            "opacity": 0.94,
                        }),
                    };
                case "top":
                    return {};
            }
        })()),
        "childrenWrapper": __assign(__assign({}, theme.spacing.rightLeft("padding", paddingRightLeft + "px")), (function () {
            switch (headerPosition) {
                case "fixed":
                    return {
                        "paddingTop": headerHeight,
                        "height": "100%",
                        "zIndex": 1,
                        "overflow": "auto",
                        "scrollBehavior": "smooth",
                    };
                case "top":
                    return {};
            }
        })()),
    };
});
var GlTemplateInner = react_1.memo(function (props) {
    var header = props.header, isThemeProvidedOutside = props.isThemeProvidedOutside, headerPosition = props.headerPosition, children = props.children;
    {
        var hideRootSplashScreen_1 = onyxia_ui_1.useSplashScreen().hideRootSplashScreen;
        react_1.useEffect(function () {
            if (isThemeProvidedOutside) {
                return;
            }
            hideRootSplashScreen_1();
        }, []);
    }
    var _a = onyxia_ui_2.useDomRect(), headerWrapperRef = _a.ref, headerHeight = _a.domRect.height;
    var _b = onyxia_ui_2.useDomRect(), childrenWrapperRef = _b.ref, rootWidth = _b.domRect.width;
    var _c = __read(react_1.useState(true), 2), isHeaderVisible = _c[0], setIsHeaderVisible = _c[1];
    var classes = useStyles({
        rootWidth: rootWidth,
        headerHeight: headerHeight,
        isHeaderVisible: isHeaderVisible,
        "headerPosition": (function () {
            switch (headerPosition) {
                case "fixed":
                case "fixed with auto-hide":
                    return "fixed";
                case "top":
                    return "top";
            }
        })(),
    }).classes;
    hooks_1.useElementEvt(function (_a) {
        var ctx = _a.ctx, element = _a.element;
        if (headerPosition !== "fixed with auto-hide") {
            return;
        }
        var previousScrollTop = 0;
        evt_1.Evt.from(ctx, element, "scroll").attach(function (e) {
            var scrollTop = e.target.scrollTop;
            setIsHeaderVisible(scrollTop < previousScrollTop
                ? true
                : scrollTop <= headerHeight);
            previousScrollTop = scrollTop;
        });
    }, childrenWrapperRef, [headerHeight, headerPosition]);
    return (jsx_runtime_1.jsxs("div", __assign({ className: classes.root }, { children: [jsx_runtime_1.jsx("div", __assign({ className: classes.headerWrapper, ref: headerWrapperRef }, { children: header }), void 0),
            jsx_runtime_1.jsx("div", __assign({ className: classes.childrenWrapper, ref: childrenWrapperRef }, { children: children }), void 0)] }), void 0));
});
exports.GlTemplate = react_1.memo(function (props) {
    var _a = props.ThemeProvider, ThemeProvider = _a === void 0 ? theme_1.ThemeProviderDefault : _a, SplashScreenLogo = props.SplashScreenLogo, splashScreenLogoFillColor = props.splashScreenLogoFillColor, rest = __rest(props, ["ThemeProvider", "SplashScreenLogo", "splashScreenLogoFillColor"]);
    var isThemeProvided = ThemeProvider_1.useIsThemeProvided();
    var children = (jsx_runtime_1.jsx(GlTemplateInner, __assign({}, rest, { isThemeProvidedOutside: isThemeProvided }), void 0));
    return isThemeProvided ? (children) : (jsx_runtime_1.jsx(ThemeProvider, __assign({ splashScreen: SplashScreenLogo === undefined
            ? undefined
            : {
                "Logo": SplashScreenLogo,
                "fillColor": splashScreenLogoFillColor,
                "minimumDisplayDuration": 0,
            } }, { children: children }), void 0));
});
//# sourceMappingURL=GlTemplate.js.map