"use strict";
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.useNumberCountUpAnimation = void 0;
var react_1 = require("react");
function useNumberCountUpAnimation(params) {
    var number = params.number, intervalMs = params.intervalMs;
    var _a = __read(react_1.useState(0), 2), renderedNumber = _a[0], setRenderedNumber = _a[1];
    var ref = react_1.useRef(null);
    function animate() {
        if (number === undefined) {
            return;
        }
        var count = 0;
        var interval = setInterval(function () {
            if (count === number) {
                clearInterval(interval);
                return;
            }
            count++;
            setRenderedNumber(count);
        }, intervalMs);
    }
    react_1.useEffect(function () {
        if (!ref.current) {
            animate();
            return;
        }
        var observer = new IntersectionObserver(function (entries) {
            if (!entries[0].isIntersecting) {
                return;
            }
            animate();
            observer.unobserve(entries[0].target);
        });
        observer.observe(ref.current);
    }, [number]);
    return { renderedNumber: renderedNumber, ref: ref };
}
exports.useNumberCountUpAnimation = useNumberCountUpAnimation;
//# sourceMappingURL=useNumberCountUpAnimation.js.map